<template>
    <div v-if="stateForAll && !stateForAll.running" class="sw-gs-start-presentation">
        <SwButton v-if="!startIsLoading"
                  class="sw-gs-start-presentation-btn color-light"
                  :title="$t('Start presentation')"
                  :disabled="isPreview"
                  @click="onStartPresentation">
            {{ isPreview ? $t('Preview presentation') : $t('Start presentation') }}
        </SwButton>
        <SfLoader v-else :loading="startIsLoading" class="sw-gs-start-presentation-btn"/>
    </div>
</template>

<script lang="ts">
import { SfLoader } from "@storefront-ui/vue";
import SwButton from "@/components/atoms/SwButton.vue";
import {useAppointment} from "../logic/composables/useAppointment";
import {useState} from "../logic/composables/useState";
import {ref} from '@vue/composition-api';

export default {
    name: "SwGsStartAppointment",
    components: {
        SfLoader,
        SwButton
    },
    setup() {
      const {stateForAll} = useState();
      const {isPreview, start} = useAppointment();
      const startIsLoading = ref(false);

      async function onStartPresentation() {
        startIsLoading.value = true;
        await start();
        startIsLoading.value = false;
      }

        return {
            stateForAll,
            startIsLoading,
            isPreview,
            onStartPresentation
        }
    }
}
</script>

<style lang="scss" scoped>
@import "@/assets/scss/variables";

.sw-gs-start-presentation {
    width: 100%;
    height: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
    padding: 15px 0;

    @include for-desktop {
        padding: 8px 0;
    }
}

.sw-gs-start-presentation-btn {
    ::v-deep {
        .sf-loader {
            width: 22px;
            height: 22px;
        }

        .sf-loader__overlay {
            background: none;
        }
    }
}
</style>
